// ClbSys.h
//
//	Project : CASSIOPEIA LIBRARY (PX-798)
//	Author  : Takafumi NAOI (TSR)
//	Date    : 05/14/2002
//	
//	Copyright (C) 2002 CASIO COMPUTER CO.,LTD.
//	CASIO CONFIDENTIAL
//
#ifndef __CLB_LIB__
#define __CLB_LIB__

#ifdef __cplusplus
extern "C" {
#endif

// Prototypes
extern BOOL  WINAPI CLBSetBootableButtons(DWORD);
extern BOOL  WINAPI CLBGetBootableButtons(DWORD *);
extern BOOL  WINAPI CLBSetOffMaskTime(DWORD, DWORD);
extern BOOL  WINAPI CLBGetOffMaskTime(DWORD *, DWORD *);
extern VOID  WINAPI CLBPowerOff(void);
extern BOOL  WINAPI CLBDisablePowerOff(void);
extern BOOL  WINAPI CLBEnablePowerOff(void);
extern BOOL  WINAPI CLBGetPowerOff(void);
extern BOOL  WINAPI CLBAPODisable(void);
extern BOOL  WINAPI CLBAPOEnable(void);
extern BOOL  WINAPI CLBAPOGet(void);
extern VOID  WINAPI CLBSoftReset(void);
extern BOOL  WINAPI CLBSetIndicator(DWORD, DWORD, DWORD, DWORD);
extern DWORD WINAPI CLBGetIndicator(VOID);
extern int   WINAPI CLBCheckCharger(DWORD);
extern BOOL  WINAPI CLBCardDetectDisable(DWORD);
extern BOOL  WINAPI CLBCardDetectEnable(DWORD);
extern BOOL  WINAPI CLBCardDetectGet(DWORD);
extern BOOL  WINAPI CLBSetFnButtons(BOOL);
extern BOOL  WINAPI CLBGetFnButtons(void);
extern BOOL  WINAPI CLBSetInputChangeButtons(DWORD);
extern DWORD WINAPI CLBGetInputChangeButtons(void);
extern BOOL  WINAPI CLBSetKeyLock(BOOL);
extern BOOL  WINAPI CLBGetKeyLock(void);
extern BOOL  WINAPI CLBPlayBuzzer(DWORD, DWORD, DWORD);
extern BOOL  WINAPI CLBStopBuzzer(void);
extern BOOL  WINAPI CLBSetBuzzerVolume(DWORD, DWORD);
extern DWORD WINAPI CLBGetBuzzerVolume(DWORD);
extern BOOL  WINAPI CLBSetBuzzerMute(DWORD, BOOL);
extern BOOL  WINAPI CLBGetBuzzerMute(DWORD);
extern BOOL  WINAPI CLBSetCPUMode(DWORD);
extern BOOL  WINAPI CLBGetCPUMode(DWORD *);
extern BOOL  WINAPI CLBSet180Rotate(BOOL);
extern BOOL  WINAPI CLBGet180Rotate(void);
extern BOOL  WINAPI CLBGetDeviceIDCode(TCHAR *);
extern BOOL  WINAPI CLBGetUserIDCode(WORD *);
extern BOOL  WINAPI CLBPrepareLED(DWORD, DWORD, DWORD, DWORD);
extern BOOL  WINAPI CLBUpdateLED(DWORD);

// Bootable Buttons
#define CLB_BUTTON_LEFTTRIGGER	0x1000
#define CLB_BUTTON_RIGHTTRIGGER	0x0800
#define CLB_BUTTON_IOBOX		0x0400
#define CLB_BUTTON_ARRIVAL		0x0200
#define CLB_BUTTON_NONE			0x0000

#define CLB_BUTTON_DEFAULT		(CLB_BUTTON_IOBOX)

// INDICATOR MODE
#define CLB_LED_OFF				0x0000
#define CLB_LED_GREEN			0x0001
#define CLB_LED_RED				0x0002
#define CLB_LED_ORANGE			(CLB_LED_GREEN | CLB_LED_RED)

// INPUT CHANGE BUTTON
#define CLB_BUTTON_NORMAL		0x0000
#define CLB_BUTTON_LOCK_NUM		0x0001
#define CLB_BUTTON_LOCK_HIRA	0x0002
#define CLB_BUTTON_LOCK_KANA	0x0003
#define CLB_BUTTON_LOCK_ALPHA	0x0004
#define CLB_BUTTON_LOCK_ALPHAS	0x0005

// BUZZER TYPE
#define CLB_BUZZER_DEFAULT		0x0000
#define B_TAP					0x0000
#define B_CLICK					0x0001
#define B_ALARM					0x0002
#define B_WARNING				0x0003
#define B_SCANEND				0x0004
#define B_USERDEF				0x0005
#define B_ALL					0x0006

// BUZZER VOLUME
#define CLB_BUZZERVOLUME_MIN	0x0001
#define CLB_BUZZERVOLUME_MID	0x0002
#define CLB_BUZZERVOLUME_MAX	0x0003

// CPU MODE
#define CLB_CPUMODE_LOW			0x0200
#define CLB_CPUMODE_MIDDLE		0x0300
#define CLB_CPUMODE_HIGH		0x0400

// CardDetect
#define TYPE_PCMCIA				0x0000
#define TYPE_CF					0x0001

#ifdef __cplusplus
};
#endif

#endif
