#include <windows.h>
#include <commctrl.h>
#include "TDdecodece.h"
#include "ClbSys.h"
#include "resource.h"


extern BOOL g_bStreaming;
extern int  g_iLine;
int    g_PictureNumber = 1;


extern void ShowErrorMessage(HWND hDlg, TCHAR *szErr);
extern TCHAR szErrMemory[64];


TCHAR CodeList[][32] = {
	TEXT("Aztec / AztecMesa"),	TEXT("Aztec Mesa"),		TEXT("Codabar(NW7)"),
	TEXT("Code11"),		TEXT("Code128"),		TEXT("Code39"),
	TEXT("Code49"),		TEXT("Code93"),			TEXT("Composite / RSS"),
	TEXT("DataMatrix"),	TEXT("EAN / JAN"),		TEXT("EAN / JAN 13"),
	TEXT("Interleaved2of5(ITF)"),TEXT("Maxicode"),TEXT("MicroPDF"),
	TEXT("OCR"),		TEXT("PDF417"),			TEXT("Postnet"),
	TEXT("QR"),			TEXT("RSS"),			TEXT("UPCA / UPCE"),
	TEXT("UPCE"),		TEXT("UPCE1"),			TEXT("ISBT"),
	TEXT(""),			TEXT(""),				TEXT(""),
	TEXT("IATA2of5"),	TEXT("CodaBlock"),		TEXT(""),
	TEXT("Planet"),		TEXT(""),				TEXT("MSI / Plessy"),
	TEXT("TLCode39") };



// show bitmap data
void showbmp(HWND hWnd, int left, int top, int w, int h, int Width, int Height, BYTE *ImageBuffer)
{
	HBITMAP		hBmp, hOrgBmp;
	HDC			hdcMem, hdc;
	int			Size, i, j;
	BYTE		*data;
	
	// 8bit --> 24bit
	Size = Width * Height;
	data = (BYTE*)malloc(Size*3);
	i = 0;
	for(j=0; j<Size; j++) {
		data[i++] = ImageBuffer[j];
		data[i++] = ImageBuffer[j];
		data[i++] = ImageBuffer[j];
	}
	
	
	hdc		= GetDC(hWnd);
	hdcMem	= CreateCompatibleDC(hdc);
	hBmp	= CreateBitmap(Width, Height, 1, 24, data);
	hOrgBmp = (HBITMAP)SelectObject(hdcMem, hBmp);
	
	StretchBlt(hdc, left, top, w, h, hdcMem, 0, 0, Width, Height, SRCCOPY);
	
	SelectObject(hdcMem, hOrgBmp);
	DeleteObject(hBmp);
	DeleteDC(hdcMem);
	
	ReleaseDC(hWnd, hdc);
	free( data );
}


// draw white rectangle to initialize window
int ResetDisp(HWND hWnd)
{
	HDC hdc;
	hdc = GetDC(hWnd);
	Rectangle(hdc, -5, -5, 250, 300);
	ReleaseDC(hWnd, hdc);
	return 0;
}



// draw text in window
void PrintText(HWND hWnd, TCHAR *Text, int nLength, int *pos)
{
	HDC		hdc;
	TCHAR	buf[100];
	int		j, k=0, Line, Last, pos2;
	int		step, maxx, maxy, left, top;

	pos2	= *pos;	// current line number
	step	= 14;	// height 1 line
	maxx	= 32;	// max chars in 1 line
	maxy	= 18;	// max line
	left	= 8;	// starting left position
	top		= 25;	// starting top position
	
	// initialize display
	if(pos2 > maxy)	pos2 = ResetDisp(hWnd);

	hdc = GetDC(hWnd);
	Line = nLength/maxx;
	Last = nLength%maxx;

	for(j=0;j<Line;j++){
		for(k=0;k<maxx;k++) buf[k]=Text[j*maxx+k];
		ExtTextOut(	hdc, left, top+step*(pos2++)+j,
					0,	NULL, buf,maxx, NULL);
	}
	j=0;
	for(k=0;k<Last;k++)	buf[k]=Text[nLength-Last+j++];

	ExtTextOut(	hdc, left, top+step*(pos2++), 0, NULL,
				buf,Last, NULL);
	*pos = pos2;

	ReleaseDC(hWnd, hdc);
}



// paste clipboard
void PasteClipboard(void)
{
	keybd_event(VK_CONTROL, 0, KEYEVENTF_SILENT, 0);// Key Ctl
	keybd_event(0x56, 0, KEYEVENTF_SILENT, 0);		// Key 'v'
	keybd_event(0x56, 0, KEYEVENTF_KEYUP, 0);
	keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
	keybd_event(0x0d, 0, KEYEVENTF_SILENT, 0);		// Key Enter
}


// copy clipboard
BOOL CopyClipboard(HWND hWnd, TCHAR *str)
{
	HGLOBAL		hGlobal;
	PTSTR		strMem;

	hGlobal = GlobalAlloc(GHND | GMEM_SHARE, sizeof(TCHAR)*(wcslen(str)+1));
    if(hGlobal == NULL){
		ShowErrorMessage(hWnd, szErrMemory);
		return FALSE;
	}
	strMem = (PTSTR)GlobalLock(hGlobal);
	lstrcpy(strMem, str);
    GlobalUnlock(hGlobal);

    if (!OpenClipboard(hWnd)) return FALSE;
	EmptyClipboard();
	SetClipboardData(CF_UNICODETEXT , hGlobal);
	CloseClipboard();
	return TRUE;
}


// check trigger key
BOOL Trigger(void)
{
	if(GetAsyncKeyState(0x87) < 0 )	return TRUE;
	else							return FALSE;
}

// get symbol number form ID
int GetSymbolNum(TCHAR CodeID)
{
	char cID;
	cID = (char)CodeID;
	
	switch(cID){
		case SYMID_AUSPOST:		return SYM_AUSPOST;
		case SYMID_AZTEC:		return SYM_AZTEC;
		//case SYMID_MESA:		return SYM_MESA;
		case SYMID_BPO:			return SYM_BPO;
		case SYMID_CANPOST:		return SYM_CANPOST;
		case SYMID_CODABAR:		return SYM_CODABAR;
		case SYMID_CODABLOCK:	return SYM_CODABLOCK;
		case SYMID_CODE11:		return SYM_CODE11;
		case SYMID_CODE128:		return SYM_CODE128;
		case SYMID_CODE39:		return SYM_CODE39;
		case SYMID_CODE49:		return SYM_CODE49;
		case SYMID_CODE93:		return SYM_CODE93;
		case SYMID_COMPOSITE:	return SYM_COMPOSITE;
		case SYMID_DATAMATRIX:	return SYM_DATAMATRIX;
		case SYMID_DUTCHPOST:	return SYM_DUTCHPOST;
		case SYMID_EAN:			return SYM_EAN8;
		case SYMID_IATA25:		return SYM_IATA25;
		case SYMID_INT25:		return SYM_INT25;
		case SYMID_JAPOST:		return SYM_JAPOST;
		case SYMID_MAXICODE:	return SYM_MAXICODE;
		case SYMID_MICROPDF:	return SYM_MICROPDF;
		case SYMID_MSI:			return SYM_MSI;
		case SYMID_PDF417:		return SYM_PDF417;
		case SYMID_PLANET:		return SYM_PLANET;
		case SYMID_POSTNET:		return SYM_POSTNET;
		case SYMID_OCR:			return SYM_OCR;
		case SYMID_QR:			return SYM_QR;
		//case SYMID_RSS:		return SYM_RSS;
		case SYMID_TLC39:		return SYM_TLCODE39;
		case SYMID_UPC:			return SYM_UPCA;
	}
	return -1;
}

// read symbole & copy clipboard
Result_t ReadSymbol(HWND hWnd)
{
	TCHAR		wcMessage[4100], chCodeID, chSymLetter, chSymModifier;
	WORD		nLength;
	Result_t	Result;
	int			i;
	
	ZeroMemory( wcMessage, sizeof wcMessage );
	
	Result = TDWaitForDecode( 10000, wcMessage, &chCodeID, &chSymLetter,
							  &chSymModifier, &nLength, Trigger );
	
	i = GetSymbolNum(chCodeID);
	
	if( Result==RESULT_SUCCESS ) {
		// copy to clipboard
		CopyClipboard(hWnd, wcMessage);
		SetDlgItemText(hWnd, IDC_STATIC1, CodeList[i]);
		SetDlgItemInt(hWnd, IDC_STATIC2, nLength, TRUE);
		// paste from clipboard
		PasteClipboard();
	}
	
	return Result;
}




// read symbol dialog
LRESULT CALLBACK DlgReadSymbol(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	BOOL  ResPeek;
	MSG   msg;
	
	switch (message){
		case WM_INITDIALOG:
			RegisterHotKey(hDlg, ID_HOTKEY_L, 0, 0x87);
			RegisterHotKey(hDlg, ID_HOTKEY_R, MOD_KEYUP, 0x84);
			return TRUE;
			
		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case IDCANCEL:
					UnregisterHotKey(hDlg, ID_HOTKEY_L);
					UnregisterHotKey(hDlg, ID_HOTKEY_R);
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
			}
			break;
		case WM_HOTKEY:
			switch(wParam){
				case ID_HOTKEY_L:
					ReadSymbol(hDlg);
					break;
					
				case ID_HOTKEY_R:
					if(GetAsyncKeyState(0x84) < 0) TDAimerOn(TRUE);
					else                           TDAimerOn(FALSE);
					break;
			}// switch(wParam)
			// clear key input
			do{
				ResPeek = PeekMessage(&msg , hDlg, WM_HOTKEY, WM_HOTKEY, PM_REMOVE);
			}while(ResPeek == TRUE);
			
			break;

			break;
	}// switch(message)
    return FALSE;
}

// capture & show image
void CaptureImage(HWND hWnd, BOOL bSave)
{
	DWORD		Size;
	WORD		nTop,nLeft,nRight,nBottom,nSkip,nBits;
	FileFormat_t	nFormat;
	WORD		nWhiteValue,nExposeAttempts,nGap;
	BOOL		Invert;
	Result_t	Result;
	BYTE		*img_data;
	int			img_size, img_width, img_height;

	// set parameters
	nTop			= 0;
	nLeft			= 0;
	nRight			= 640;
	nBottom			= 480;
	nSkip			= 1;
	if(bSave) nSkip = 2;
	nBits			= 8;
	nFormat			= FF_RAW_GRAY;
	nWhiteValue		= 0;
	nExposeAttempts	= 5;
	nGap			= 1;
	Invert			= FALSE;
	
	img_width = ( nRight - nLeft ) / nSkip;
	img_height= ( nBottom - nTop ) / nSkip;
	img_size  = img_width * img_height;
	img_data  = ( BYTE* )malloc( img_size );
	if( img_data == NULL ){
		ShowErrorMessage( hWnd, szErrMemory );
		return;
	}
	memset(img_data, 0, img_size);
	// capture & get image data
	Result = TDGetImage( img_data, &Size, nTop, nLeft, nRight, nBottom, nSkip, nBits,
						 nFormat, nWhiteValue, nExposeAttempts, nGap, Invert, NULL );
	// show image data
	showbmp(hWnd, 0, 60, 240, 180, img_width, img_height, img_data);
	
	if( bSave ){
		// save image data
		TCHAR		szFname[80];
		ZeroMemory(szFname, sizeof szFname);
		wsprintf(szFname, TEXT("\\My Documents\\TDDemo\\Picture%.2d.bmp"), g_PictureNumber++);
		TDMakeImageFile( szFname, img_data, Size, img_width, img_height, IMG_FORMAT_BMP );
		
	}
	free( img_data );
}



// capture & show streaming image
DWORD ShowStreaming(HWND hWnd)
{
	BYTE		*img_data;
	DWORD		readnum;
	int			nSkip, img_width, img_height, img_size;
	RECT		rt;
	BOOL		Flip;
	
	// set parameters
	nSkip		= 4;
	rt.left		= 0;
	rt.top		= 0;
	rt.right	= 640;
	rt.bottom	= 480;
	Flip		= FALSE;
	
	img_width = ( rt.right - rt.left ) / nSkip;
	img_height= ( rt.bottom - rt.top ) / nSkip;
	img_size  = img_width * img_height;
	img_data  = ( BYTE* )malloc( img_size );
	if( img_data == NULL ){
		ShowErrorMessage( hWnd, szErrMemory );
		ExitThread( 1 );
		return 0;
	}
	memset( img_data, 0, img_size );
	
	g_bStreaming = TRUE;
	// (1) initialize streaming
	TDImageStreamInit( nSkip, &rt, Flip );
	// (2) start streaming
	TDImageStreamStart();
	
	while(1){
		// (3) read streaming
		TDImageStreamRead( img_data, &readnum );
		showbmp( hWnd, 40, 80, img_width, img_height, img_width, img_height, img_data );
		if( !g_bStreaming ) break;
	}
	// (4) stop streaming
	TDImageStreamStop();
	free( img_data );
	ExitThread( 1 );
	return 0;
}



// capture sign
Result_t CaptureSign(HWND hWnd)
{
	Result_t        Result;
	IntellImgDesc_t ImageDesc;
	int pos = 0;
	// set parameters
	ImageDesc.AspectRatio	= 30; // = (narrow bar height / narrow bar width)
	ImageDesc.OffsetX		= 33; // X axis: center of sign from center of barcode
	ImageDesc.OffsetY		= 63; // Y axis: center of sign from center of barcode
	ImageDesc.width			= 80; // width of sign
	ImageDesc.height		= 80; // height of sign
	ImageDesc.resolution	= 4;  // resolution of sign
	ImageDesc.format		= FF_RAW_GRAY;
	ImageDesc.reserved		= -1;
	// sign capture
	Result = TDStartIntellImgXfer( &ImageDesc );
	return Result;
}

// show sign
Result_t ShowSign(HWND hWnd)
{
	Result_t Result;
	BYTE		*img_data;
	DWORD		img_size, readnum, img_height, img_width;
	int			resolution, pos=0;
	
	resolution = 4;
	img_width = 80 * resolution;
	img_height= 80 * resolution;
	img_size  = img_width * img_height;
	img_data  = ( BYTE* )malloc( img_size );
	
	if( img_data==NULL ){
		ShowErrorMessage(hWnd, szErrMemory);
		return RESULT_ERR_MEMORY;
	}
	// get sign image data
	Result=TDGetImageData( img_size, img_data, &readnum );
	
	if(Result==RESULT_SUCCESS){
		showbmp( hWnd, 20, 70, 200, 200, img_width, img_height, img_data );
	}
	free( img_data );
	return Result;
}



// capture & show sign
void CaptureShowSign(HWND hWnd)
{
	TCHAR		wcMessage[4096], chCodeID, chSymLetter, chSymModifier;
	WORD		nLength;
	Result_t	Result1, Result2 = RESULT_INITIALIZE;
	
	// prepare LED
	TDSetIndicator( TD_LED_OFF, TD_BUZZER_OFF );
	CLBPrepareLED( CLB_LED_GREEN, 4,1,3 );
	
	// start sign capture
	do {
		ZeroMemory(wcMessage, sizeof wcMessage);
	    
	    Result1 = TDWaitForDecode (
	    	10000, wcMessage, &chCodeID, &chSymLetter,
	    	&chSymModifier, &nLength, Trigger );
		
		if(Result1 == RESULT_SUCCESS){
			Result2 = CaptureSign( hWnd );
			if(Result2 == RESULT_SUCCESS) {
				break;
			}
		}
	} while( Trigger() );
	
	// notify a result
	if(Result2 != RESULT_SUCCESS) {
		TDSetIndicator( TD_LED_ON, TD_BUZZER_ON );
		return;
	} else {
		CLBPlayBuzzer( B_SCANEND, 0, 0 );
		CLBUpdateLED( CLB_LED_GREEN );
	}
	
	// show sign image data
	// clear a line
	g_iLine = 1;
	PrintText( hWnd, TEXT("                               "),  31, &g_iLine );
	g_iLine = 1;
	PrintText( hWnd, wcMessage, wcslen(wcMessage), &g_iLine );
	ShowSign( hWnd );
	TDSetIndicator( TD_LED_ON, TD_BUZZER_ON );
	
	return;
}



